/* mem-misc.h */

/* macros et variables diverses */

#ifndef _misc_
#define _misc_


#ifndef NULL
#define NULL 0
#endif

#define false 0
#define true 1

#ifdef ANSI
#define VOID void
#else
#define VOID char
#endif


#ifdef DEBUG

#ifdef ANSI
extern void failed_assert (char *, char *, unsigned long);
#else
extern void failed_assert ();
#endif

#ifdef ANSI

#define Zassert(x) \
  { if (!(x)) failed_assert ( #x , __FILE__, (unsigned long) __LINE__); }

#else
#ifdef __LINE__

#define Zassert(x) \
  { if (!(x)) failed_assert ("(?)" , __FILE__, (unsigned long) __LINE__); }

#else

#define Zassert(x) \
  { if (!(x)) failed_assert ("(?)" , "(?)", 0l); }

#endif
#endif

#else /* DEBUG */

#define Zassert(x) ;

#endif /* DEBUG */


extern unsigned long verb_gc;

#ifdef ANSI
char * itoa(char * buf, unsigned long num);
extern void gc_message (char *, unsigned long, char *);
extern void gc_message_str (char *);
extern void fatal_error (char *);
extern void fatal_unix_error (char *, char *);
#else
extern void gc_message ();
extern void gc_message_str ();
extern void fatal_error ();
extern void fatal_unix_error ();
#endif /* ANSI */

#ifdef DEBUG
unsigned long gc_debug_random();
#endif

#endif /* _misc_ */
