/* stacks.h : structure des piles */

#ifndef _stacks_
#define _stacks_

/* 1- la pile A (arguments) : (value (bien construite) | mark)*  */

#define MARK ((value) 0)

/* 2- la pile R (retour & cache d'environnements) : une succession de

   adr.hautes				OU

	N valeurs valides			N valeurs valides
	return_frame avec cache_size = N	trap_frame avec cache_size=N+2
		...
   adr.basses
*/

struct return_frame {
  code pc;
  value env;
  int cache_size;
/*value cache[cache_size] */
};

struct trap_frame {
  code pc;
  value env;
  int cache_size;
  value * asp;
  struct trap_frame * tp;
/*value cache[cache_size] */
};

extern value * arg_stack_low;
extern value * arg_stack_high;
extern value * arg_stack_threshold;
extern value * ret_stack_low;
extern value * ret_stack_high;
extern value * ret_stack_threshold;
extern value * extern_asp;
extern value * extern_rsp;
extern struct trap_frame * tp;
extern value global_data;
extern value *C_roots_head;

#ifdef ANSI

void reset_roots(void);
void init_stacks(unsigned long arg_stack_size, unsigned long ret_stack_size);
void realloc_stacks(void);

#else

void reset_roots();
void init_stacks();
void realloc_stacks();

#endif

#endif

